#include <stdio.h>
#include <vector>

void solve() {
    int n, m, k;
    int a, b, c;
    std::vector<int> raptors;
    std::vector<std::vector<int> > r;
    scanf("%d%d%d", &n, &m, &k);
    scanf("%d%d%d", &a, &b, &c);
    for (int i = 0; i < k; i++) {
        int rp;
        scanf("%d", &rp);
        raptors.push_back(rp);
    }

    std::vector<int> mask;
    for (int i = 0; i <= n; i++)
        mask.push_back(10000);

    for (int i = 0; i < n; i++)
        r.resize(n + 1, mask);

    for (int i = 0; i < m; i++) {
        int a, b, c;
        scanf("%d%d%d", &a, &b, &c);
        r[a][b] = std::min(r[a][b], c);
        r[b][a] = std::min(r[b][a], c);
    }

    for (int k = 1; k <= n; k++)
        for (int i = 1; i <= n; i++)
            for (int j = 1; j <= n; j++)
                r[i][j] = std::min(r[i][j], r[i][k] + r[k][j]);

    int labRaptors = 10000;
    for (int i = 0; i < k; i++)
        labRaptors = std::min(labRaptors, r[raptors[i]][b]);

    if (labRaptors <= r[a][b] * 2) {
        printf("Raptors are happy\n");
    } else {
        printf("Pasha vanished somewhere\n");
        int helicopterRaptors = 10000;
        for (int i = 0; i < k; i++)
            helicopterRaptors = std::min(helicopterRaptors, r[raptors[i]][c]);

        if (helicopterRaptors <= r[a][c] * 3)
            printf("Raptors are happy a little\n");
        else {
            printf("Dasha hid in the village\n");
        }
    }
}

int main()
{
    solve();
    return 0;
}
